<template>
  <div class="layout-page">
    <div v-if="!!$slots.header" class="layouts-header">
      <slot name="header"></slot>
    </div>
    <div class="layouts-grid">
      <div v-if="!!$slots.sidebar" class="layouts-grid__sidebar">
        <slot name="sidebar"></slot>
      </div>
      <div class="layouts-grid__container">
        <slot name="content"></slot>
      </div>
      <div v-if="!!$slots.footer" class="layouts-grid__footer">
        <slot name="footer"></slot>
      </div>
    </div>
    <slot />
    <SidebarContainer>
      <template v-if="profilePage">
        <SidebarProfile />
      </template>
      <template v-else>
        <SidebarMenu />
      </template>
    </SidebarContainer>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import SidebarContainer from '@/components/app/SidebarContainer.vue'
import SidebarProfile from '@/components/app/SidebarProfile.vue'
import SidebarMenu from '@/components/app/SidebarMenu.vue'
export default defineComponent<{
  profilePage?: boolean
}>({
  name: 'Container',
  props: ['profilePage'],
  components: { SidebarMenu, SidebarProfile, SidebarContainer }
})
</script>

<style lang="scss" scoped>
.layouts-grid {
  margin: 0 auto;
  max-width: 1920px;
  display: grid;
  grid-template-areas: 'sidebar' 'content';
  grid-template-columns: 100%;
  padding-right: 15px;
  padding-left: 15px;
  padding-top: 70px;
  @media (min-width: 1199.98px) {
    grid-template-areas: 'sidebar content';
    grid-template-columns: 300px auto;
    grid-gap: 30px;
    padding-top: 0px;
    padding-right: 30px;
    padding-left: 30px;
  }
  @media (min-width: 1400px) {
    grid-template-areas: 'sidebar content';
    grid-template-columns: 350px auto;
    grid-column-gap: 100px;
  }

  &__sidebar {
    grid-area: sidebar;
    @media (min-width: 1199.98px) {
      min-height: 100vh;
    }
  }
  &__container {
    grid-area: content;
    max-width: 100%;
  }
}
</style>
